#pragma once

#include "vec3f.h"

namespace geometry {

class Cylinder {
public:
  Cylinder() = default;
  explicit Cylinder(float radius);
  Cylinder(float radius, math::Vec3f origin, math::Vec3f direction);

  float radius() const;
  math::Vec3f origin() const;
  math::Vec3f direction() const;

  void radius(float radius);
  void origin(math::Vec3f origin);
  void direction(math::Vec3f direction);

public:
  float m_radius = 1.f;
  math::Vec3f m_origin;
  math::Vec3f m_direction = math::Vec3f(0.f, 0.f, 1.f);
};

} // namespace geometry
