#pragma once

#include "cylinder.h"
#include "ray.h"
#include "vec3f.h"

// nonstd
#include "optional.hpp"

namespace geometry {
bool willIntersect(Ray const &ray, Cylinder const &cylinder);

struct Intersection {
  math::Vec3f point;
  math::Vec3f normal;
  Intersection(math::Vec3f point, math::Vec3f normal);
};

nonstd::optional<Intersection> calculateIntersection(Ray const &ray,
                                                     Cylinder const &cylinder);
} // namespace geometry
