#pragma once

#include "vec3f.h"

namespace geometry {
class Ray {
public:
  Ray() = default;
  explicit Ray(math::Vec3f origin);
  Ray(math::Vec3f origin, math::Vec3f direction);

  math::Vec3f origin() const;
  math::Vec3f direction() const;

private:
  math::Vec3f m_origin;
  math::Vec3f m_direction;
};

math::Vec3f evaluate(Ray const &ray, float t);

} // namespace geometry
