/**
 * @file	triangle_mesh_file_io.h
 * @author	Andrew Robert Owens
 * @date 	2018-2-27.
 * @brief	CollisionExample: triangle_mesh_file_io.h
 * @details Organization: Biological Modeling and Visualization research group
 * University of Calgary, Calgary, AB, Canada
 *
 * Contact:	arowens [at] ucalgary.ca
 * @copyright Copyright (c) 2018 ___ALGORITHMIC_BOTANY___. All rights reserved.
 *
 * @brief
 */

#pragma once

#include <string>

#include "triangle_mesh.h"
// nonstd
#include "optional.hpp"

namespace geometry {

nonstd::optional<geometry::TriangleMesh>
loadTriangleMeshFromFile(std::string const &filePath);

} // namespace geometry
