#pragma once

#include <limits>

namespace math {

// Solve roots (r[0],r[1]) of Quadratic Polynomial of form
// ax^2 + bx + c = 0
// outputs number of real roots found
int solveQuadraticRoots(
    float const &a, float const &b, float const &c, float r[2],
    float const EPSILON = std::numeric_limits<float>::epsilon());

// Solve roots (r[0],r[1]) of Quadratic Polynomial of form
// c[2]x^2 + c[1]x + c[0] = 0
// outputs number of real roots found
int solveQuadraticRoots(
    float c[3], float r[2],
    float const EPSILON = std::numeric_limits<float>::epsilon());

// Solve root (r[0]) of Linear Polynomial of form
// ax + b = 0
// outputs number of real roots found
int solveLinearRoots(
    float const &a, float const &b, float r[1],
    float const EPSILON = std::numeric_limits<float>::epsilon());

// Solve root (r[0]) of Linear Polynomial of form
// c[1]x + c[0] = 0
// outputs number of real roots found
int solveLinearRoots(
    float c[2], float r[1],
    float const EPSILON = std::numeric_limits<float>::epsilon());

} // namespace math
