#version 330
layout( location = 0 ) in vec3 vertex_modelSpace;
layout( location = 1 ) in vec3 normal_modelSpace;
layout( location = 2 ) in vec3 color;
layout( location = 3 ) in mat4 instancedMatrix;

uniform mat4 P; // projection matrix
uniform mat4 V; // view matrix

out VertexData
{
    vec3 position_worldSpace;
    vec3 normal_worldSpace;
    vec3 color;
} vertexData;

void main()
{
   vertexData.position_worldSpace = vertex_modelSpace;
   vertexData.normal_worldSpace =
           transpose(inverse(mat3(instancedMatrix))) * normal_modelSpace;
   vertexData.color = color * vec3(gl_InstanceID/400., 1.f, 1.f);

   gl_Position = P * V * instancedMatrix * vec4( vertex_modelSpace, 1.0 );
}
