#include "cylinder.h"

namespace geometry {

Cylinder::Cylinder(float radius) : m_radius(radius) {}

Cylinder::Cylinder(float radius, math::Vec3f origin, math::Vec3f direction)
    : m_radius(radius), m_origin(origin), m_direction(direction) {}

float Cylinder::radius() const { return m_radius; }

math::Vec3f Cylinder::origin() const { return m_origin; }

math::Vec3f Cylinder::direction() const { return m_direction; }

void Cylinder::radius(float radius) { m_radius = radius; }

void Cylinder::origin(math::Vec3f origin) { m_origin = origin; }

void Cylinder::direction(math::Vec3f direction) { m_direction = direction; }

} // namespace geometry
