#include "ray.h"

namespace geometry {

Ray::Ray(math::Vec3f origin) : m_origin(origin) {}

Ray::Ray(math::Vec3f origin, math::Vec3f direction)
    : m_origin(origin), m_direction(direction) {}

math::Vec3f Ray::origin() const { return m_origin; }

math::Vec3f Ray::direction() const { return m_direction; }

// Free functions

math::Vec3f evaluate(Ray const &ray, float t) {
  return ray.origin() + t * ray.direction();
}

} // namespace geometry
