/**
 * @file	shader_file_io.cpp
 * @author	Andrew Robert Owens
 * @date 	2018-2-27.
 * @brief	CollisionExample: shader_file_io.cpp
 * @details Organization: Biological Modeling and Visualization research group
 * University of Calgary, Calgary, AB, Canada
 *
 * Contact:	arowens [at] ucalgary.ca
 * @copyright Copyright (c) 2018 ___ALGORITHMIC_BOTANY___. All rights reserved.
 *
 * @brief
 */

#include "shader.h"

#include <fstream>
#include <iostream>

namespace openGL {

std::string loadShaderStringFromFile(const std::string &filePath) {
  std::string shaderCode;
  std::ifstream fileStream(filePath);
  if (fileStream.good()) {
    std::string line;
    while (std::getline(fileStream, line)) {
      shaderCode += "\n" + line;
    }
    fileStream.close();

  } else {
    std::cerr << "Could Not Open File " << filePath << std::endl;
    return {""};
  }
  return shaderCode;
}

} // namespace openGL
